#define ResetVector                             0x00
#define ExternalInt0Vector                      0x02
#define ExternalInt1Vector                      0x04
#define Timer2CompareIntVector                  0x06
#define Timer2OverflowIntVector                 0x08
#define Timer1CaptureIntVector                  0x0A
#define Timer1CompareAIntVector                 0x0C
#define Timer1CompareBIntVector                 0x0E
#define Timer1OverflowIntVector                 0x10
#define Timer0OverflowIntVector                 0x12
#define SPITransferCompleteIntVector            0x14
#define UARTReceiveIntVector                    0x16
#define UARTDataEmptyIntVector                  0x18
#define UARTTransmitIntVector                   0x1A
#define ADCConversionCompleteIntVector          0x1C
#define EEPROMReadyIntVector                    0x1E
#define ComparatorIntVector                     0x20
#define TwoWireSerialIntVector                  0x22
#define FlashReadyIntVector                     0x24

#define TWIBitRate                              0x00

#define TWIStatus                               0x01
#define BTWIPrescaler0                          0
#define BTWIPrescaler1                          1
#define TWISystemClockDiv4                      0x01
#define TWISystemClockDiv16                     0x02
#define TWISystemClockDiv64                     0x03

#define TWIAddress                              0x02
#define BTWIGeneralCallEnable                   0
#define TWIGeneralCallEnable                    0x01

#define TWIData                                 0x03

#define ADCDataLow                              0x04

#define ADCDataHigh                             0x05

#define ADCControl                              0x06
#define BADCPrescaler0                          0
#define BADCPrescaler1                          1
#define BADCPrescaler2                          2
#define BADCInterruptEnable                     3
#define BADCInterruptFlag                       4
#define BADCFreeRunSelect                       5
#define BADCStartConversion                     6
#define BADCEnable                              7
#define ADCSystemClockDiv2                      0x01
#define ADCSystemClockDiv4                      0x02
#define ADCSystemClockDiv8                      0x03
#define ADCSystemClockDiv16                     0x04
#define ADCSystemClockDiv32                     0x05
#define ADCSystemClockDiv64                     0x06
#define ADCSystemClockDiv128                    0x07
#define ADCInterruptEnable                      0x08
#define ADCInterruptFlag                        0x10
#define ADCFreeRunSelect                        0x20
#define ADCStartConversion                      0x40
#define ADCEnable                               0x80

#define ADCMux                                  0x07
#define BADCChannelSelect0                      0
#define BADCChannelSelect1                      1
#define BADCChannelSelect2                      2
#define BADCChannelSelect3                      3
#define BADCLeftAdjustResult                    5
#define BADCReferenceSelect0                    6
#define BADCReferenceSelect1                    7
#define ADCChannel0                             0x00
#define ADCChannel1                             0x01
#define ADCChannel2                             0x02
#define ADCChannel3                             0x03
#define ADCChannel4                             0x04
#define ADCChannel5                             0x05
#define ADCChannel6                             0x06
#define ADCChannel7                             0x07
#define ADCBandgapChannel                       0x0E
#define ADCGroundChannel                        0x0F
#define ADCLeftAdjustResult                     0x20
#define ADCExternalReference                    0x00
#define ADCVccReference                         0x40
#define ADCInternalReference                    0xC0

#define AnalogComparator                        0x08
#define BACIntModeSelect0                       0
#define BACIntModeSelect1                       1
#define BACInputCaptureEnable                   2
#define BACInterruptEnable                      3
#define BACInterruptFlag                        4
#define BACOutput                               5
#define BACBandgapSelect                        6
#define BACDisable                              7
#define ACOutputToggleInt                       0x00
#define ACFallingOutputEdgeInt                  0x02
#define ACRisingOutputEdgeInt                   0x03
#define ACInputCaptureEnable                    0x04
#define ACInterruptEnable                       0x08
#define ACInterruptFlag                         0x10
#define ACOutput                                0x20
#define ACBandgapSelect                         0x40
#define ACDisable                               0x80

#define UARTBaudRateLow                         0x09

#define UARTControl                             0x0A
#define BUARTTransmitBit8                       0
#define BUARTReceiveBit8                        1
#define BUART9BitCharacters                     2
#define BUARTTransmitterEnable                  3
#define BUARTReceiverEnable                     4
#define BUARTDataEmptyInterruptEnable           5
#define BUARTTransmitInterruptEnable            6
#define BUARTReceiveInterruptEnable             7
#define UARTTransmitBit8                        0x01
#define UARTReceiveBit8                         0x02
#define UART9BitCharacters                      0x04
#define UARTTransmitterEnable                   0x08
#define UARTReceiverEnable                      0x10
#define UARTDataEmptyInterruptEnable            0x20
#define UARTTrasmitInterruptEnable              0x40
#define UARTReceiveInterruptEnable              0x80

#define UARTStatus                              0x0B
#define BUARTMultiProcessorMode                 0
#define BUARTDoubleSpeed                        1
#define BUARTParityError                        2
#define BUARTOverrun                            3
#define BUARTFramingError                       4
#define BUARTDataRegisterEmpty                  5
#define BUARTTransmitComplete                   6
#define BUARTReceiveComplete                    7
#define UARTMultiProcessorMode                  0x01
#define UARTDoubleSpeed                         0x02
#define UARTParityError                         0x04
#define UARTOverrun                             0x08
#define UARTFramingError                        0x10
#define UARTDataRegisterEmpty                   0x20
#define UARTTransmitCompete                     0x40
#define UARTReceiveComplete                     0x80

#define UARTData                                0x0C

#define SPIControl                              0x0D
#define BSPIClockSelect0                        0
#define BSPIClockSelect1                        1
#define BSPIClockPhase                          2
#define BSPIClockPolarity                       3
#define BSPIMasterMode                          4
#define BSPIDataOrder                           5
#define BSPIEnable                              6
#define BSPIInterruptEnable                     7
#define SPISystemClockDiv4                      0x00
#define SPISystemClockDiv16                     0x01
#define SPISystemClockDiv64                     0x02
#define SPISystemClockDiv128                    0x03
#define SPIClockPhase                           0x04
#define SPIClockPolarity                        0x08
#define SPIMasterMode                           0x10
#define SPILSBFirst                             0x20
#define SPIEnable                               0x40
#define SPIInterruptEnable                      0x80

#define SPIStatus                               0x0E
#define BSPIDoubleSpeed                         0
#define BSPIWriteCollision                      6
#define BSPITransferComplete                    7
#define SPIDoubleSpeed                          0x01
#define SPIWriteCollision                       0x40
#define SPITransferComplete                     0x80

#define SPIData                                 0x0F

#define PortDPins                               0x10
#define PortDDirection                          0x11
#define PortDData                               0x12
#define PortCPins                               0x13
#define PortCDirection                          0x14
#define PortCData                               0x15
#define PortBPins                               0x16
#define PortBDirection                          0x17
#define PortBData                               0x18

#define BPortPin0                               0
#define BPortPin1                               1
#define BPortPin2                               2
#define BPortPin3                               3
#define BPortPin4                               4
#define BPortPin5                               5
#define BPortPin6                               6
#define BPortPin7                               7
#define PortPin0                                0x01
#define PortPin1                                0x02
#define PortPin2                                0x04
#define PortPin3                                0x08
#define PortPin4                                0x10
#define PortPin5                                0x20
#define PortPin6                                0x40
#define PortPin7                                0x80

#define EEPROMControl                           0x1C
#define BEEPROMReadEnable                       0
#define BEEPROMWriteEnable                      1
#define BEEPROMMasterWriteEnable                2
#define BEEPROMReadyInterruptEnable             3
#define EEPROMReadEnable                        0x01
#define EEPROMWriteEnable                       0x02
#define EEPROMMasterWriteEnable                 0x04
#define EEPROMReadyInterruptEnable              0x08

#define EEPROMData                              0x1D
#define EEPROMAddressLow                        0x1E
#define EEPROMAddressHigh                       0x1F

#define UARTBaudRateHigh                        0x20
#define UARTSettings                            0x20
#define BUARTClockPolarity                      0
#define BUARTCharacterSize0                     1
#define BUARTCharacterSize1                     2
#define BUARTTwoStopBits                        3
#define BUARTParityMode0                        4
#define BUARTParityMode1                        5
#define BUARTSynchronousMode                    6
#define BUARTControlRegisterSelect              7
#define UARTClockPolarity                       0x01
#define UART5BitCharacters                      0x00
#define UART6BitCharacters                      0x02
#define UART7BitCharacters                      0x04
#define UART8BitCharacters                      0x06
#define UARTTwoStopBits                         0x08
#define UARTParityDisabled                      0x00
#define UARTEvenParity                          0x20
#define UARTOddParity                           0x30
#define UARTSynchronousMode                     0x40
#define UARTControlRegisterSelect               0x80

#define WDControl                               0x21
#define BWDPrescaler0                           0
#define BWDPrescaler1                           1
#define BWDPrescaler2                           2
#define BWDEnable                               3
#define BWDChangeEnable                         4
#define WDPrescaler16K                          0x00
#define WDPrescaler32K                          0x01
#define WDPrescaler64K                          0x02
#define WDPrescaler128K                         0x03
#define WDPrescaler256K                         0x04
#define WDPrescaler512K                         0x05
#define WDPrescaler1024K                        0x06
#define WDPrescaler2048K                        0x07
#define WDEnable                                0x08
#define WDChangeEnable                          0x10

#define Timer2AsynchronousStatus                0x22
#define BTimer2ControlUpdateBusy                0
#define BTimer2OutputCompareUpdateBusy          1
#define BTimer2CounterUpdateBusy                2
#define BTimer2Asynchronous                     3
#define Timer2ControlUpdateBusy                 0x01
#define Timer2OutputCompareUpdateBusy           0x02
#define Timer2CounterUpdateBusy                 0x04
#define Timer2Asynchronous                      0x08

#define Timer2OutputCompare                     0x23

#define Timer2Value                             0x24

#define Timer2Control                           0x25
#define BTimer2ClockSelect0                     0
#define BTimer2ClockSelect1                     1
#define BTimer2ClockSelect2                     2
#define BTimer2WaveformGenerationMode1          3
#define BTimer2CompareOutputMode0               4
#define BTimer2CompareOutputMode1               5
#define BTimer2WaveformGenerationMode0          6
#define BTimer2ForceOutputCompare               7
#define TimerStopped                            0x00
#define Timer2SystemClock                       0x01
#define Timer2SystemClockDiv8                   0x02
#define Timer2SystemClockDiv32                  0x03
#define Timer2SystemClockDiv64                  0x04
#define Timer2SystemClockDiv128                 0x05
#define Timer2SystemClockDiv256                 0x06
#define Timer2SystemClockDiv1024                0x07
#define Timer2ToggleOutputCompare               0x10
#define Timer2ClearOutputCompare                0x20
#define Timer2SetOutputCompare                  0x30
#define Timer2PhaseCorrectPWM                   0x40
#define Timer2ClearOnCompareMatch               0x08
#define Timer2FastPWM                           0x48
#define Timer2ForceOutputCompare                0x80

#define Timer1InputCaptureLow                   0x26

#define Timer1InputCaptureHigh                  0x27

#define Timer1OutputCompareBLow                 0x28

#define Timer1OutputCompareBHigh                0x29

#define Timer1OutputCompareALow                 0x2A

#define Timer1OutputCompareAHigh                0x2B

#define Timer1ValueLow                          0x2C

#define Timer1ValueHigh                         0x2D

#define Timer1ControlB                          0x2E
#define BTimerClockSelect0                      0
#define BTimerClockSelect1                      1
#define BTimerClockSelect2                      2
#define BTimer1WaveformGenerationMode2          3
#define BTimer1WaveformGenerationMode3          4
#define BTimer1InputCaptureEdgeSelect           6
#define BTimer1InputCaptureNoiseCanceler        7
#define TimerStopped                            0x00
#define TimerSystemClock                        0x01
#define TimerSystemClockDiv8                    0x02
#define TimerSystemClockDiv64                   0x03
#define TimerSystemClockDiv256                  0x04
#define TimerSystemClockDiv1024                 0x05
#define TimerFallingExternalPinEdge             0x06
#define TimerRisingExternalPinEdge              0x07
#define Timer1WaveformGenerationMode2           0x08
#define Timer1WaveformGenerationMode3           0x10
#define Timer1InputCaptureFallingEdge           0x00
#define Timer1InputCaptureRisingEdge            0x40
#define Timer1InputCaptureNoiseCanceler         0x80

#define Timer1ControlA                          0x2F
#define BTimer1WaveformGenerationMode0          0
#define BTimer1WaveformGenerationMode1          1
#define BTimer1ForceOutputCompareB              2
#define BTimer1ForceOutputCompareA              3
#define BTimer1OutputCompareBMode0              4
#define BTimer1OutputCompareBMode1              5
#define BTimer1OutputCompareAMode0              6
#define BTimer1OutputCompareAMode1              7
#define Timer1ForceOutputCompareB               0x04
#define Timer1ForceOutputCompareA               0x08
#define Timer1ToggleOutputCompareB              0x10
#define Timer1ClearOutputCompareB               0x20
#define Timer1SetOutputCompareB                 0x30
#define Timer1ToggleOutputCompareA              0x40
#define Timer1ClearOutputCompareA               0x80
#define Timer1SetOutputCompareA                 0xC0

#define SpecialFunction                         0x30
#define BSFTimersPrescalerReset                 0
#define BSFTimer2PrescalerReset                 1
#define BSFPullUpDisable                        2
#define BSFComparatorMultiplexerEnable          3
#define SFTimersPrescalerReset                  0x01
#define SFTimer2PrescalerReset                  0x02
#define SFPullUpDisable                         0x04
#define SFComparatorMultiplexerEnable           0x08

#define OscillatorCalibration                   0x31

#define Timer0Value                             0x32

#define Timer0Control                           0x33

#define MCUStatus                               0x34
#define BMCUPowerOnReset                        0
#define BMCUExternalReset                       1
#define BMCUBrownOutReset                       2
#define BMCUWatchDogReset                       3
#define MCUPowerOnReset                         0x01
#define MCUExternalReset                        0x02
#define MCUBrownOutReset                        0x04
#define MCUWatchDogReset                        0x08

#define MCUControl                              0x35
#define BMCUInt0SenseControl0                   0
#define BMCUInt0SenseControl1                   1
#define BMCUInt1SenseControl0                   2
#define BMCUInt1SenseControl1                   3
#define BMCUSleepMode0                          4
#define BMCUSleepMode1                          5
#define BMCUSleepMode2                          6
#define BMCUSleepEnable                         7
#define MCULowLevelInt0                         0x00
#define MCULevelChangeInt0                      0x01
#define MCUFallingEdgeInt0                      0x02
#define MCURisingEdgeInt0                       0x03
#define MCULowLevelInt1                         0x00
#define MCULevelChangeInt1                      0x04
#define MCUFallingEdgeInt1                      0x08
#define MCURisingEdgeInt1                       0x0C
#define MCUSleepModeIsIdle                      0x00
#define MCUSleepModeIsADCNR                     0x10
#define MCUSleepModeIsPowerDown                 0x20
#define MCUSleepModeIsPowerSave                 0x30
#define MCUSleepModeIsStandby                   0x60
#define MCUSleepEnable                          0x80

#define TWIControl                              0x36
#define BTWIInterruptEnable                     0
#define BTWIEnable                              2
#define BTWIWriteCollision                      3
#define BTWIStopCondition                       4
#define BTWIStartCondition                      5
#define BTWIEnableAcknowledge                   6
#define BTWIInterruptFlag                       7
#define TWIInterruptEnable                      0x01
#define TWIEnable                               0x04
#define TWIWriteCollision                       0x08
#define TWIStopCondition                        0x10
#define TWIStartCondition                       0x20
#define TWIEnableAcknowledge                    0x40
#define TWIInterruptFlag                        0x80

#define SPMControl                              0x37
#define BSPMEnable                              0
#define BSPMPageErase                           1
#define BSPMPageWrite                           2
#define BSPMBootLockBitSet                      3
#define BSPMRWWSectionReadEnable                4
#define BSPMRWWSectionBusy                      6
#define BSPMInterruptEnable                     7
#define SPMEnable                               0x01
#define SPMPageErase                            0x02
#define SPMPageWrite                            0x04
#define SPMBootLockBitSet                       0x08
#define SPMRWWSectionReadEnable                 0x10
#define SPMRWWSectionBusy                       0x40
#define SPMInterruptEnable                      0x80

#define TimerInterruptFlag                      0x38
#define BTimer0OverflowFlag                     0
#define BTimer1OverflowFlag                     2
#define BTimer1OutputCompareBMatchFlag          3
#define BTimer1OutputCompareAMatchFlag          4
#define BTimer1InputCaptureFlag                 5
#define BTimer2OverflowFlag                     6
#define BTimer2OutputCompareMatchFlag           7
#define Timer0OverflowFlag                      0x01
#define Timer1OverflowFlag                      0x04
#define Timer1OutputCompareBMatchFlag           0x08
#define Timer1OutputCompareAMatchFlag           0x10
#define Timer1InputCaptureFlag                  0x20
#define Timer2OverflowFlag                      0x40
#define Timer2OutputCompareMatchFlag            0x80

#define TimerInterruptMask                      0x39
#define BTimer0OverflowInterruptEnable          0
#define BTimer1OverflowInterruptEnable          2
#define BTimer1OutputCompareBInterruptEnable    3
#define BTimer1OutputCompareAInterruptEnable    4
#define BTimer1InputCaptureInterruptEnable      5
#define BTimer2OverflowInterruptEnable          6
#define BTimer2OutputCompareInterruptEnable     7
#define Timer0OverflowInterruptEnable           0x01
#define Timer1OverflowInterruptEnable           0x04
#define Timer1OutputCompareBInterruptEnable     0x08
#define Timer1OutputCompareAInterruptEnable     0x10
#define Timer1InputCaptureInterruptEnable       0x20
#define Timer2OverflowInterruptEnable           0x40
#define Timer2OutputCompareInterruptEnable      0x80

#define GeneralInterruptFlags                   0x3A
#define BExternalInt0Flag                       6
#define BExternalInt1Flag                       7
#define ExternalInt0Flag                        0x40
#define ExternalInt1Flag                        0x80

#define GeneralInterruptControl                 0x3B
#define BInterruptVectorChangeEnable            0
#define BInterruptVectorSelect                  1
#define BExternalInt0Enable                     6
#define BExternalInt1Enable                     7
#define InterruptVectorChangeEnable             0x01
#define InterruptVectorSelect                   0x02
#define ExternalInt0Enable                      0x40
#define ExternalInt1Enable                      0x80

#define StackPointerLow                         0x3D

#define StackPointerHigh                        0x3E

#define StatusRegister                          0x3F
#define BCarryFlag                              0
#define BZeroFlag                               1
#define BNegativeFlag                           2
#define BTwoComplementOverflowFlag              3
#define BSignBit                                4
#define BHalfCarryFlag                          5
#define BBitCopyStorage                         6
#define BGlobalInterruptEnable                  7
#define CarryFlag                               0x01
#define ZeroFlag                                0x02
#define NegativeFlag                            0x04
#define TwoComplementOverflowFlag               0x08
#define SignBit                                 0x10
#define HalfCarryFlag                           0x20
#define BitCopyStorage                          0x40
#define GlobalInterruptEnable                   0x80

#define XLow                                    R26
#define XHigh                                   R27
#define YLow                                    R28
#define YHigh                                   R29
#define ZLow                                    R30
#define ZHigh                                   R31
