#pragma language=extended

#define ResetVector                             0x00
#define ExternalInt0Vector                      0x02
#define ExternalInt1Vector                      0x04
#define Timer2CompareIntVector                  0x06
#define Timer2OverflowIntVector                 0x08
#define Timer1CaptureIntVector                  0x0A
#define Timer1CompareAIntVector                 0x0C
#define Timer1CompareBIntVector                 0x0E
#define Timer1OverflowIntVector                 0x10
#define Timer0OverflowIntVector                 0x12
#define SPITransferCompleteIntVector            0x14
#define UARTReceiveIntVector                    0x16
#define UARTDataEmptyIntVector                  0x18
#define UARTTransmitIntVector                   0x1A
#define ADCConversionCompleteIntVector          0x1C
#define EEPROMReadyIntVector                    0x1E
#define ComparatorIntVector                     0x20
#define TwoWireSerialIntVector                  0x22
#define FlashReadyIntVector                     0x24

__io unsigned char TWIBitRate@0x00;

__io union
{
  unsigned char TWIStatus;
  struct
  {
    unsigned char BTWIPrescaler:2, BTWISReserved:1, BTWIStatus:5;
  };
}@0x01;

#define TWISystemClockDiv4                      0x01
#define TWISystemClockDiv16                     0x02
#define TWISystemClockDiv64                     0x03

__io union
{
  unsigned char TWISlaveAddress;
  struct
  {
    unsigned char BTWIGeneralCallEnable:1, BTWISlaveAddress:7;
  };
}@0x02;

#define TWIGeneralCallEnable                    0x01

__io unsigned char TWIData@0x03;

__io union
{
  unsigned short ADCData;
  struct
  {
    unsigned char ADCDataLow, ADCDataHigh;
  };
}@0x04;

__io union
{
  unsigned char ADCControl;
  struct
  {
    unsigned char BADCPrescaler:3, BADCInterruptEnable:1, BADCInterruptFlag:1, BADCFreeRunSelect:1, BADCStartConversion:1, BADCEnable:1;
  };
}@0x06;

#define ADCSystemClockDiv2                      0x01
#define ADCSystemClockDiv4                      0x02
#define ADCSystemClockDiv8                      0x03
#define ADCSystemClockDiv16                     0x04
#define ADCSystemClockDiv32                     0x05
#define ADCSystemClockDiv64                     0x06
#define ADCSystemClockDiv128                    0x07
#define ADCInterruptEnable                      0x08
#define ADCInterruptFlag                        0x10
#define ADCFreeRunSelect                        0x20
#define ADCStartConversion                      0x40
#define ADCEnable                               0x80

__io union
{
  unsigned char ADCMux;
  struct
  {
    unsigned char BADCChannelSelect:4, BADCReserved:1, BADCLeftAdjustResult:1, BADCReferenceSelect:2;
  };
}@0x07;

#define ADCChannel0                             0x00
#define ADCChannel1                             0x01
#define ADCChannel2                             0x02
#define ADCChannel3                             0x03
#define ADCChannel4                             0x04
#define ADCChannel5                             0x05
#define ADCChannel6                             0x06
#define ADCChannel7                             0x07
#define ADCBandgapChannel                       0x0E
#define ADCGroundChannel                        0x0F
#define ADCLeftAdjustResult                     0x20
#define ADCExternalReference                    0x00
#define ADCVccReference                         0x40
#define ADCInternalReference                    0xC0

__io union
{
  unsigned char AnalogComparator;
  struct
  {
    unsigned char BACIntModeSelect:2, BACInputCaptureEnable:1, BACInterruptEnable:1, BACInterruptFlag:1, BACOutput:1, BACBandgapSelect:1, BACDisable:1;
  };
}@0x08;

#define ACOutputToggleInt                       0x00
#define ACFallingOutputEdgeInt                  0x02
#define ACRisingOutputEdgeInt                   0x03
#define ACInputCaptureEnable                    0x04
#define ACInterruptEnable                       0x08
#define ACInterruptFlag                         0x10
#define ACOutput                                0x20
#define ACBandgapSelect                         0x40
#define ACDisable                               0x80

__io unsigned char UARTBaudRateLow@0x09;

__io union
{
  unsigned char UARTControl;
  struct
  {
    unsigned char BUARTTransmitBit8:1, BUARTReceiveBit8:1, BUART9BitCharacters:1, BUARTTransmitterEnable:1, BUARTReceiverEnable:1, BUARTDataEmptyInterruptEnable:1, BUARTTransmitInterruptEnable:1, BUARTReceiveInterruptEnable:1;
  };
}@0x0A;

#define UARTTransmitBit8                        0x01
#define UARTReceiveBit8                         0x02
#define UART9BitCharacters                      0x04
#define UARTTransmitterEnable                   0x08
#define UARTReceiverEnable                      0x10
#define UARTDataEmptyInterruptEnable            0x20
#define UARTTransmitInterruptEnable             0x40
#define UARTReceiveInterruptEnable              0x80

__io union
{
  unsigned char UARTStatus;
  struct
  {
    unsigned char BUARTMultiProcessorMode:1, BUARTDoubleSpeed:1, BUARTParityError:1, BUARTOverrun:1, BUARTFramingError:1, BUARTDataRegisterEmpty:1, BUARTTransmitComplete:1, BUARTReceiveComplete:1;
  };
}@0x0B;

#define UARTMultiProcessorMode                  0x01
#define UARTDoubleSpeed                         0x02
#define UARTParityError                         0x04
#define UARTOverrun                             0x08
#define UARTFramingError                        0x10
#define UARTDataRegisterEmpty                   0x20
#define UARTTransmitCompete                     0x40
#define UARTReceiveComplete                     0x80

__io unsigned char UARTData@0x0C;

__io union
{
  unsigned char SPIControl;
  struct
  {
    unsigned char BSPIClockSelect:2, BSPIClockPhase:1, BSPIClockPolarity:1, BSPIMasterMode:1, BSPIDataOrder:1, BSPIEnable:1, BSPIInterruptEnable:1;
  };
}@0x0D;

#define SPISystemClockDiv4                      0x00
#define SPISystemClockDiv16                     0x01
#define SPISystemClockDiv64                     0x02
#define SPISystemClockDiv128                    0x03
#define SPIClockPhase                           0x04
#define SPIClockPolarity                        0x08
#define SPIMasterMode                           0x10
#define SPILSBFirst                             0x20
#define SPIEnable                               0x40
#define SPIInterruptEnable                      0x80

__io union
{
  unsigned char SPIStatus;
  struct
  {
    unsigned char BSPIDoubleSpeed:1, BSPIReserved:5, BSPIWriteCollision:1, BSPITransferComplete:1;
  };
}@0x0E;

#define SPIDoubleSpeed                          0x01
#define SPIWriteCollision                       0x40
#define SPITransferComplete                     0x80

__io unsigned char SPIData@0x0F;

__io union
{
  unsigned char PortDPins;
  struct
  {
    unsigned char BPortDPin0:1, BPortDPin1:1, BPortDPin2:1, BPortDPin3:1, BPortDPin4:1, BPortDPin5:1, BPortDPin6:1, BPortDPin7:1;
  };
}@0x10;

#define PortPin0                                0x01
#define PortPin1                                0x02
#define PortPin2                                0x04
#define PortPin3                                0x08
#define PortPin4                                0x10
#define PortPin5                                0x20
#define PortPin6                                0x40
#define PortPin7                                0x80

__io union
{
  unsigned char PortDDirection;
  struct
  {
    unsigned char BPortDDirection0:1, BPortDDirection1:1, BPortDDirection2:1, BPortDDirection3:1, BPortDDirection4:1, BPortDDirection5:1, BPortDDirection6:1, BPortDDirection7:1;
  };
}@0x11;

__io union
{
  unsigned char PortDData;
  struct
  {
    unsigned char BPortDData0:1, BPortDData1:1, BPortDData2:1, BPortDData3:1, BPortDData4:1, BPortDData5:1, BPortDData6:1, BPortDData7:1;
  };
}@0x12;

__io union
{
  unsigned char PortCPins;
  struct
  {
    unsigned char BPortCPin0:1, BPortCPin1:1, BPortCPin2:1, BPortCPin3:1, BPortCPin4:1, BPortCPin5:1, BPortCPin6:1, BPortCPinReserved:1;
  };
}@0x13;

__io union
{
  unsigned char PortCDirection;
  struct
  {
    unsigned char BPortCDirection0:1, BPortCDirection1:1, BPortCDirection2:1, BPortCDirection3:1, BPortCDirection4:1, BPortCDirection5:1, BPortCDirection6:1, BPortCDirectionReserved:1;
  };
}@0x14;

__io union
{
  unsigned char PortCData;
  struct
  {
    unsigned char BPortCData0:1, BPortCData1:1, BPortCData2:1, BPortCData3:1, BPortCData4:1, BPortCData5:1, BPortCData6:1, BPortCDataReserved:1;
  };
}@0x15;

__io union
{
  unsigned char PortBPins;
  struct
  {
    unsigned char BPortBPin0:1, BPortBPin1:1, BPortBPin2:1, BPortBPin3:1, BPortBPin4:1, BPortBPin5:1, BPortBPin6:1, BPortBPin7:1;
  };
}@0x16;

__io union
{
  unsigned char PortBDirection;
  struct
  {
    unsigned char BPortBDirection0:1, BPortBDirection1:1, BPortBDirection2:1, BPortBDirection3:1, BPortBDirection4:1, BPortBDirection5:1, BPortBDirection6:1, BPortBDirection7:1;
  };
}@0x17;

__io union
{
  unsigned char PortBData;
  struct
  {
    unsigned char BPortBData0:1, BPortBData1:1, BPortBData2:1, BPortBData3:1, BPortBData4:1, BPortBData5:1, BPortBData6:1, BPortBData7:1;
  };
}@0x18;

__io union
{
  unsigned char EEPROMControl;
  struct
  {
    unsigned char BEEPROMReadEnable:1, BEEPROMWriteEnable:1, BEEPROMMasterWriteEnable:1, BEEPROMReadyInterruptEnable:1, BEEPROMReserved:4;
  };
}@0x1C;

#define EEPROMReadEnable                        0x01
#define EEPROMWriteEnable                       0x02
#define EEPROMMasterWriteEnable                 0x04
#define EEPROMReadyInterruptEnable              0x08

__io unsigned char EEPROMData@0x1D;

__io union
{
  unsigned short EEPROMAddress;
  struct
  {
    unsigned char EEPROMAddressLow, EEPROMAddressHigh;
  };
}@0x1E;

__io union
{
  unsigned char UARTBaudRateHigh;
  unsigned char UARTSettings;
  struct
  {
    unsigned char BUARTClockPolarity:1, BUARTCharacterSize:2, BUARTTwoStopBits:1, BUARTParityMode:2, BUARTSynchronousMode:1, BUARTControlRegisterSelect:1;
  };
}@0x20;

#define UARTClockPolarity                       0x01
#define UART5BitCharacters                      0x00
#define UART6BitCharacters                      0x02
#define UART7BitCharacters                      0x04
#define UART8BitCharacters                      0x06
#define UARTTwoStopBits                         0x08
#define UARTParityDisabled                      0x00
#define UARTEvenParity                          0x20
#define UARTOddParity                           0x30
#define UARTSynchronousMode                     0x40
#define UARTControlRegisterSelect               0x80

__io union
{
  unsigned char WDControl;
  struct
  {
    unsigned char BWDPrescaler:3, BWDEnable:1, BWDChangeEnable:1, BWDReserved:3;
  };
}@0x21;

#define WDPrescaler16K                          0x00
#define WDPrescaler32K                          0x01
#define WDPrescaler64K                          0x02
#define WDPrescaler128K                         0x03
#define WDPrescaler256K                         0x04
#define WDPrescaler512K                         0x05
#define WDPrescaler1024K                        0x06
#define WDPrescaler2048K                        0x07
#define WDEnable                                0x08
#define WDChangeEnable                          0x10

__io union
{
  unsigned char Timer2AsynchronousStatus;
  struct
  {
    unsigned char BTimer2ControlUpdateBusy:1, BTimer2OutputCompareUpdateBusy:1, BTimer2CounterUpdateBusy:1, BTimer2Asynchronous:1, BT2ASReserved:4;
  };
}@0x22;

#define Timer2ControlUpdateBusy                 0x01
#define Timer2OutputCompareUpdateBusy           0x02
#define Timer2CounterUpdateBusy                 0x04
#define Timer2Asynchronous                      0x08

__io unsigned char Timer2OutputCompare@0x23;
__io unsigned char Timer2Value@0x24;

__io union
{
  unsigned char Timer2Control;
  struct
  {
    unsigned char BTimer2ClockSelect:3, BTimer2WaveformGenerationMode1:1, BTimer2CompareOutputMode:2, BTimer2WaveformGenerationMode0:1, BTimer2ForceOutputCompare:1;
  };
}@0x25;

#define TimerStopped                            0x00
#define Timer2SystemClock                       0x01
#define Timer2SystemClockDiv8                   0x02
#define Timer2SystemClockDiv32                  0x03
#define Timer2SystemClockDiv64                  0x04
#define Timer2SystemClockDiv128                 0x05
#define Timer2SystemClockDiv256                 0x06
#define Timer2SystemClockDiv1024                0x07
#define Timer2ToggleOutputCompare               0x10
#define Timer2ClearOutputCompare                0x20
#define Timer2SetOutputCompare                  0x30
#define Timer2PhaseCorrectPWM                   0x40
#define Timer2ClearOnCompareMatch               0x08
#define Timer2FastPWM                           0x48
#define Timer2ForceOutputCompare                0x80

__io union
{
  unsigned short Timer1InputCapture;
  struct
  {
    unsigned char Timer1InputCaptureLow, Timer1InputCaptureHigh;
  };
}@0x26;

__io union
{
  unsigned short Timer1OutputCompareB;
  struct
  {
    unsigned char Timer1OutputCompareBLow, Timer1OutputCompareBHigh;
  };
}@0x28;

__io union
{
  unsigned short Timer1OutputCompareA;
  struct
  {
    unsigned char Timer1OutputCompareALow, Timer1OutputCompareAHigh;
  };
}@0x2A;

__io union
{
  unsigned short Timer1Value;
  struct
  {
    unsigned char Timer1ValueLow, Timer1ValueHigh;
  };
}@0x2C;

__io union
{
  unsigned char Timer1ControlB;
  struct
  {
    unsigned char BTimer1ClockSelect:3, BTimer1WaveformGenerationMode23:2, BTimer1ReservedB:1, BTimer1InputCaptureEdgeSelect:1, BTimer1InputCaptureNoiseCanceler:1;
  };
}@0x2E;

#define TimerSystemClock                        0x01
#define TimerSystemClockDiv8                    0x02
#define TimerSystemClockDiv64                   0x03
#define TimerSystemClockDiv256                  0x04
#define TimerSystemClockDiv1024                 0x05
#define TimerFallingExternalPinEdge             0x06
#define TimerRisingExternalPinEdge              0x07
#define Timer1WaveformGenerationMode2           0x08
#define Timer1WaveformGenerationMode3           0x10
#define Timer1InputCaptureFallingEdge           0x00
#define Timer1InputCaptureRisingEdge            0x40
#define Timer1InputCaptureNoiseCanceler         0x80

__io union
{
  unsigned char Timer1ControlA;
  struct
  {
    unsigned char BTimer1WaveformGenerationMode01:2, BTimer1ForceOutputCompareB:1, BTimer1ForceOutputCompareA:1, BTimer1OutputCompareBMode:2, BTimer1OutputCompareAMode:2;
  };
}@0x2F;

#define Timer1ForceOutputCompareB               0x04
#define Timer1ForceOutputCompareA               0x08
#define Timer1ToggleOutputCompareB              0x10
#define Timer1ClearOutputCompareB               0x20
#define Timer1SetOutputCompareB                 0x30
#define Timer1ToggleOutputCompareA              0x40
#define Timer1ClearOutputCompareA               0x80
#define Timer1SetOutputCompareA                 0xC0

__io union
{
  unsigned char SpecialFunction;
  struct
  {
    unsigned char BSFTimersPrescalerReset:1, BSFTimer2PrescalerReset:1, BSFPullUpDisable:1, BSFComparatorMultiplexerEnable:1, BSFReserved:4;
  };
}@0x30;

#define SFTimersPrescalerReset                  0x01
#define SFTimer2PrescalerReset                  0x02
#define SFPullUpDisable                         0x04
#define SFComparatorMultiplexerEnable           0x08

__io unsigned char OscillatorCalibration@0x31;

__io unsigned char Timer0Value@0x32;

__io union
{
  unsigned char Timer0Control;
  struct
  {
    unsigned char BTimer0ClockSelect:3, BTimer0Reserved:5;
  };
}@0x33;

__io union
{
  unsigned char MCUStatus;
  struct
  {
    unsigned char BMCUPowerOnReset:1, BMCUExternalReset:1, BMCUBrownOutReset:1, BMCUWatchDogReset:1, MCUReserved:4;
  };
}@0x34;

#define MCUPowerOnReset                         0x01
#define MCUExternalReset                        0x02
#define MCUBrownOutReset                        0x04
#define MCUWatchDogReset                        0x08

__io union
{
  unsigned char MCUControl;
  struct
  {
    unsigned char BMCUInt0SenseControl:2, BMCUInt1SenseControl:2, BMCUSleepMode:3, BMCUSleepEnable:1;
  };
}@0x35;

#define MCULowLevelInt0                         0x00
#define MCULevelChangeInt0                      0x01
#define MCUFallingEdgeInt0                      0x02
#define MCURisingEdgeInt0                       0x03
#define MCULowLevelInt1                         0x00
#define MCULevelChangeInt1                      0x04
#define MCUFallingEdgeInt1                      0x08
#define MCURisingEdgeInt1                       0x0C
#define MCUSleepModeIsIdle                      0x00
#define MCUSleepModeIsADCNR                     0x10
#define MCUSleepModeIsPowerDown                 0x20
#define MCUSleepModeIsPowerSave                 0x30
#define MCUSleepModeIsStandby                   0x60
#define MCUSleepEnable                          0x80

__io union
{
  unsigned char TWIControl;
  struct
  {
    unsigned char BTWIInterruptEnable:1, BTWICReserved:1, BTWIEnable:1, BTWIWriteCollision:1, BTWIStopCondition:1, BTWIStartCondition:1, BTWIEnableAcknowledge:1, BTWIInterruptFlag:1;
  };
}@0x36;

#define TWIInterruptEnable                      0x01
#define TWIEnable                               0x04
#define TWIWriteCollision                       0x08
#define TWIStopCondition                        0x10
#define TWIStartCondition                       0x20
#define TWIEnableAcknowledge                    0x40
#define TWIInterruptFlag                        0x80

__io union
{
  unsigned char SPMControl;
  struct
  {
    unsigned char BSPMEnable:1, BSPMPageErase:1, BSPMPageWrite:1, BSPMBootLockBitSet:1, BSPMRWWSectionReadEnable:1, BSPMReserved:1, BSPMRWWSectionBusy:1, BSPMInterruptEnable:1;
  };
}@0x37;

#define SPMEnable                               0x01
#define SPMPageErase                            0x02
#define SPMPageWrite                            0x04
#define SPMBootLockBitSet                       0x08
#define SPMRWWSectionReadEnable                 0x10
#define SPMRWWSectionBusy                       0x40
#define SPMInterruptEnable                      0x80

__io union
{
  unsigned char TimerInterruptFlag;
  struct
  {
    unsigned char BTimer0OverflowFlag:1, BTIFReserved:1, BTimer1OverflowFlag:1, BTimer1OutputCompareBMatchFlag:1, BTimer1OutputCompareAMatchFlag:1, BTimer1InputCaptureFlag:1, BTimer2OverflowFlag:1, BTimer2OutputCompareMatchFlag:1;
  };
}@0x38;

#define Timer0OverflowFlag                      0x01
#define Timer1OverflowFlag                      0x04
#define Timer1OutputCompareBMatchFlag           0x08
#define Timer1OutputCompareAMatchFlag           0x10
#define Timer1InputCaptureFlag                  0x20
#define Timer2OverflowFlag                      0x40
#define Timer2OutputCompareMatchFlag            0x80

__io union
{
  unsigned char TimerInterruptMask;
  struct
  {
    unsigned char BTimer0OverflowInterruptEnable:1, BTIMReserved:1, BTimer1OverflowInterruptEnable:1, BTimer1OutputCompareBInterruptEnable:1, BTimer1OutputCompareAInterruptEnable:1, BTimer1InputCaptureInterruptEnable:1, BTimer2OverflowInterruptEnable:1, BTimer2OutputCompareInterruptEnable:1;
  };
}@0x39;

#define Timer0OverflowInterruptEnable           0x01
#define Timer1OverflowInterruptEnable           0x04
#define Timer1OutputCompareBInterruptEnable     0x08
#define Timer1OutputCompareAInterruptEnable     0x10
#define Timer1InputCaptureInterruptEnable       0x20
#define Timer2OverflowInterruptEnable           0x40
#define Timer2OutputCompareInterruptEnable      0x80

__io union
{
  unsigned char GeneralInterruptFlags;
  struct
  {
    unsigned char BGIFReserved:6, BExternalInt0Flag:1, BExternalInt1Flag:1;
  };
}@0x3A;

#define ExternalInt0Flag                        0x40
#define ExternalInt1Flag                        0x80

__io union
{
  unsigned char GeneralInterruptControl;
  struct
  {
    unsigned char BInterruptVectorChangeEnable:1, BInterruptVectorSelect:1, BGICReserved:4, BExternalInt0Enable:1, BExternalInt1Enable:1;
  };
}@0x3B;

#define InterruptVectorChangeEnable             0x01
#define InterruptVectorSelect                   0x02
#define ExternalInt0Enable                      0x40
#define ExternalInt1Enable                      0x80

__io union
{
  unsigned short StackPointer;
  struct
  {
    unsigned char StackPointerLow, StackPointerHigh;
  };
}@0x3D;


__io union
{
  unsigned char StatusRegister;
  struct
  {
    unsigned char BCarryFlag:1, BZeroFlag:1, BNegativeFlag:1, BTwoComplementOverflowFlag:1, BSignBit:1, BHalfCarryFlag:1, BBitCopyStorage:1, BGlobalInterruptEnable:1;
  };
}@0x3F;

#define CarryFlag                               0x01
#define ZeroFlag                                0x02
#define NegativeFlag                            0x04
#define TwoComplementOverflowFlag               0x08
#define SignBit                                 0x10
#define HalfCarryFlag                           0x20
#define BitCopyStorage                          0x40
#define GlobalInterruptEnable                   0x80

#define false                                   0
#define true                                    1

#define Sleep() asm("Sleep")
#define WDReset() asm("WDR")
#define DisableInterrupts() asm("ClI")
#define EnableInterrupts() asm("SeI")
#define Nop() asm("Nop")

#pragma language=default
