/*
   :  .
   : I2CStatusStates.h
  : 04.06.2008
  :   c    ,      I2C
*/

//    TWI    
#define I2C_BIT_RATE 100000
#define MAX_TWI_RETRIES 2
#define BUSY 0x80
#define I2C_READ 0x01
#define I2C_WRITE 0x00

#define SIZE_OF_RECEIVE_BUFFER          13
#define SIZE_OF_TRANSMIT_BUFFER         14
#define STORE_BUFFER_SIZE               4
#define STORE_BUFFER_MASK               (STORE_BUFFER_SIZE - 1)
#if (STORE_BUFFER_SIZE & STORE_BUFFER_MASK)
#error Store buffer size is not a power of 2
#endif
//  
#define TWI_START                       0x08        //   ,      88- ,     !
#define TWI_REP_START                   0x10
#define TWI_MT_SLA_ACK                  0x18
#define TWI_MT_SLA_NACK                 0x20
#define TWI_MT_DATA_ACK                 0x28
#define TWI_MT_DATA_NACK                0x30
#define TWI_ARB_LOST                    0x38

#define TWI_MR_SLA_ACK                  0x40
#define TWI_MR_SLA_NACK                 0x48
#define TWI_MR_DATA_ACK                 0x50
#define TWI_MR_DATA_NACK                0x58

#define TWI_SR_SLA_ACK                  0x60
#define TWI_SR_ARB_LOST                 0x68
#define TWI_SR_GCALL                    0x70
#define TWI_SR_ARB_LOST_GCALL           0x78
#define TWI_SR_DATA_ACK                 0x80
#define TWI_SR_DATA_NACK                0x88
#define TWI_SR_GCALL_DATA_ACK           0x90
#define TWI_SR_GCALL_DATA_NACK          0x98
#define TWI_SR_STOP                     0xA0

#define TWI_ST_SLA_ACK                  0xA8
#define TWI_ST_ARB_LOST                 0xB0
#define TWI_ST_DATA_ACK                 0xB8
#define TWI_ST_DATA_NACK                0xC0
#define TWI_ST_LASTDATA_ACK             0xC8

#define TWI_NO_STATE_INFO               0xF8
#define TWI_BUS_ERROR                   0x00

//   
#define CM_ADDRESS            0x11

//   
#define CMC_MOVE              0x01
#define CMC_GET_INFO          0x02
#define CMC_GET_COMM_INFO     0x03
#define CMC_GET_ERROR_INFO    0x04
#define CMC_GET_STATISTICS    0x05
#define CMC_CLEAR_STATISTICS  0x06
#define CMC_STOP              0x07

// 
#define ANSWR_ERR_UNKNOWN     0x00
#define ANSWR_OK              0x01
#define ANSWR_ERROR           0x02
#define ANSWR_ERR_NO_POWER    0x03
#define ANSWR_ERR_CHARGING    0x04
#define ANSWR_ERR_OVERHEAT    0x05