#include "ATMega8.inc"
#include "EventCodes.h"

#define COMMAND_RX_FIFO_SIZE 32
#define COMMAND_RX_FIFO_MASK COMMAND_RX_FIFO_SIZE-1

#define Accumulator         R16
#define Symbol              R18

                            Name UARTReceiveVector
                            Common INTVEC:CODE:ROOT(1)
                            Org UARTReceiveIntVector
                            Extern UARTReceiveInterrupt
                            Jmp UARTReceiveInterrupt
                            EndMod

                            Name UART

                            RSeg CODE
                            Public UARTReceiveInterrupt
                            Extern CommandRxFifo
                            EXTERN UARTTransmitByte
                            Extern CommandRxFifoHead
                            Extern PlaceEvent
                            
UARTReceiveInterrupt        PUSH Accumulator
                            IN Accumulator, StatusRegister
                            PUSH Accumulator
                            PUSH Symbol
                            PUSH ZHigh
                            PUSH ZLow
                            IN Symbol, UARTData
                            LDS ZLow, CommandRxFifoHead
                            MOV Accumulator, ZLow
                            CLR ZHigh
                            SUBI ZLow, LOW(-CommandRxFifo)
                            SBCI ZHigh, HIGH(-CommandRxFifo)
                            ST Z, Symbol
                            INC Accumulator
                            ANDI Accumulator, COMMAND_RX_FIFO_MASK
                            STS CommandRxFifoHead, Accumulator
                            LDI Accumulator, EV_SERIAL_DATA_RECEIVED
                            RCALL PlaceEvent
                            POP ZLow
                            POP ZHigh
                            POP Symbol
                            POP Accumulator
                            OUT StatusRegister, Accumulator
                            POP Accumulator
                            RETI
                            
                            END